<?php

namespace App\Http\Middleware;

use Closure;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Symfony\Component\HttpFoundation\Response;

class CheckPermission
{
    /**
     * Handle an incoming request.
     *
     * @param  \Closure(\Illuminate\Http\Request): (\Symfony\Component\HttpFoundation\Response)  $next
     */
    public function handle(Request $request, Closure $next, $requiredPermission): Response
    {
        $user = auth('admins')->user();
        // dd(auth('admins')->user()->permission);
        $requiredPermission = explode('.', $requiredPermission);
        if ($user) {
            $permission = explode(',', $user->permission);

            // Kiểm tra nếu user có quyền yêu cầu
            foreach ($requiredPermission as $perm) {
                if (in_array($perm, $permission)) {
                    return $next($request);
                }
            }
        }

        // Nếu không có quyền, trả về response 403
        return response()->json(['status' => false, 'message' => 'Forbidden'], 403);
    }
}
